| Disk ARchive 2.8.3 Full featured and portable backup and archiving tool

Loading...
Searching...
No Matches
Public Member Functions | Protected Member Functions | Private Member Functions | Private Attributes | List of all members
libdar::trivial_sar Class Reference
Private

`#include <trivial_sar.hpp>`

Inherits libdar::generic_file, libdar::contextual, and libdar::mem_ui.

## Public Member Functions
| trivial_sar (const std::shared_ptr< user_interaction > &dialog, gf_mode open_mode, const std::string &base_name, const std::string &extension, const entrepot &where, const label &internal_nale, const label &data_name, const std::string &execute, bool allow_over, bool warn_over, bool force_permission, U_I permission, hash_algo x_hash, const infinint &min_digits, bool format_07_compatible)
| constructor to build a new single sliced archive
| trivial_sar (const std::shared_ptr< user_interaction > &dialog, const std::string &pipename, bool lax)
| constructor to read a (single sliced) archive from a pipe
| trivial_sar (const std::shared_ptr< user_interaction > &dialog, int filedescriptor, bool lax)
| trivial_sar (const std::shared_ptr< user_interaction > &dialog, generic_file *f, const label &internal_name, const label &data_name, bool format_07_compatible, const std::string &execute)
| constructor to write a (single sliced) archive to a anonymous pipe
| trivial_sar (const trivial_sar &ref)=delete
| copy constructor (disabled)
| trivial_sar (trivial_sar &&ref) noexcept=delete
| move constructor
trivial_sar & | operator= (const trivial_sar &ref)=delete
| assignment operator (disabled)
trivial_sar & | operator= (trivial_sar &&ref) noexcept=delete
| move operator
| ~trivial_sar ()
| destructor
virtual bool | skippable (skippability direction, const infinint &amount) override
| whether the implementation is able to skip
virtual bool | skip (const infinint &pos) override
| skip at the absolute position
virtual bool | skip_to_eof () override
| skip to the end of file
virtual bool | skip_relative (S_I x) override
| skip relatively to the current position
virtual bool | truncatable (const infinint &pos) const override
| whether the implementation is able to truncate to the given position
virtual infinint | get_position () const override
| get the current read/write position
virtual bool | is_an_old_start_end_archive () const override
| returns whether the archive is a old archive (format < 8)
virtual const label & | get_data_name () const override
| obtain the data_name of the archive (label associated with the archive's data)
const infinint & | get_slice_header_size () const
| size of the slice header
void | disable_natural_destruction ()
| disable execution of user command when destroying the current object
void | enable_natural_destruction ()
| enable back execution of user command when destroying the current object
Public Member Functions inherited from libdar::generic_file
| generic_file (gf_mode m)
| main constructor
| generic_file (const generic_file &ref)
| copy constructor
| generic_file (generic_file &&ref) noexcept
| move constructor
generic_file & | operator= (const generic_file &ref)
| assignment operator
generic_file & | operator= (generic_file &&ref) noexcept
| move operator
| ~generic_file () noexcept(false)
| virtual destructor,
void | terminate ()
| destructor-like call, except that it is allowed to throw exceptions
bool | operator== (generic_file &ref)
bool | operator!= (generic_file &ref)
gf_mode | get_mode () const
| retreive the openning mode for this object
void | read_ahead (const infinint &amount)
void | ignore_read_ahead (bool mode)
virtual U_I | read (char *a, U_I size) override
| read data from the generic_file inherited from proto_generic_file
virtual void | write (const char *a, U_I size) override
| write data to the generic_file inherited from proto_generic_file
void | write (const std::string &arg)
| write a string to the generic_file
S_I | read_back (char &a)
| skip back one char, read on char and skip back one char
S_I | read_forward (char &a)
| read one char
virtual void | truncate (const infinint &pos)
| truncate file at the given offset
virtual void | copy_to (generic_file &ref)
| copy all data from current position to the object in argument
virtual void | copy_to (generic_file &ref, const infinint &crc_size, crc *&value)
| copy all data from the current position to the object in argument and computes a CRC value of the transmitted data
U_32 | copy_to (generic_file &ref, U_32 size)
| small copy (up to 4GB) with CRC calculation
infinint | copy_to (generic_file &ref, infinint size)
| copy the given amount to the object in argument
bool | diff (generic_file &f, const infinint &me_read_ahead, const infinint &you_read_ahead, const infinint &crc_size, crc *&value)
| compares the contents with the object in argument
bool | diff (generic_file &f, const infinint &me_read_ahead, const infinint &you_read_ahead, const infinint &crc_size, crc *&value, infinint &err_offset)
void | reset_crc (const infinint &width)
| reset CRC on read or writen data
bool | crc_status () const
| to known whether CRC calculation is activated or not
crc * | get_crc ()
| get CRC of the transfered date since last reset
void | sync_write ()
| write any pending data
void | flush_read ()
| be ready to read at current position, reseting all pending data for reading, cached and in compression engine for example
| generic_file (gf_mode m)
| main constructor
| generic_file (const generic_file &ref)
| copy constructor
| generic_file (generic_file &&ref) noexcept
| move constructor
generic_file & | operator= (const generic_file &ref)
| assignment operator
generic_file & | operator= (generic_file &&ref) noexcept
| move operator
| ~generic_file () noexcept(false)
| virtual destructor,
void | terminate ()
| destructor-like call, except that it is allowed to throw exceptions
bool | operator== (generic_file &ref)
bool | operator!= (generic_file &ref)
gf_mode | get_mode () const
| retreive the openning mode for this object
void | read_ahead (const infinint &amount)
void | ignore_read_ahead (bool mode)
virtual U_I | read (char *a, U_I size) override
| read data from the generic_file inherited from proto_generic_file
virtual void | write (const char *a, U_I size) override
| write data to the generic_file inherited from proto_generic_file
void | write (const std::string &arg)
| write a string to the generic_file
S_I | read_back (char &a)
| skip back one char, read on char and skip back one char
S_I | read_forward (char &a)
| read one char
virtual void | truncate (const infinint &pos)
| truncate file at the given offset
virtual void | copy_to (generic_file &ref)
| copy all data from current position to the object in argument
virtual void | copy_to (generic_file &ref, const infinint &crc_size, crc *&value)
| copy all data from the current position to the object in argument and computes a CRC value of the transmitted data
U_32 | copy_to (generic_file &ref, U_32 size)
| small copy (up to 4GB) with CRC calculation
infinint | copy_to (generic_file &ref, infinint size)
| copy the given amount to the object in argument
bool | diff (generic_file &f, const infinint &me_read_ahead, const infinint &you_read_ahead, const infinint &crc_size, crc *&value)
| compares the contents with the object in argument
bool | diff (generic_file &f, const infinint &me_read_ahead, const infinint &you_read_ahead, const infinint &crc_size, crc *&value, infinint &err_offset)
void | reset_crc (const infinint &width)
| reset CRC on read or writen data
bool | crc_status () const
| to known whether CRC calculation is activated or not
crc * | get_crc ()
| get CRC of the transfered date since last reset
void | sync_write ()
| write any pending data
void | flush_read ()
| be ready to read at current position, reseting all pending data for reading, cached and in compression engine for example
Public Member Functions inherited from libdar::proto_generic_file
| proto_generic_file (const proto_generic_file &ref)=default
| copy constructor
| proto_generic_file (proto_generic_file &&ref) noexcept=default
| move constructor
proto_generic_file & | operator= (const proto_generic_file &ref)=default
| assignment operator
proto_generic_file & | operator= (proto_generic_file &&ref) noexcept=default
| move operator
virtual | ~proto_generic_file () noexcept(false)
| virtual destructor
| proto_generic_file (const proto_generic_file &ref)=default
| copy constructor
| proto_generic_file (proto_generic_file &&ref) noexcept=default
| move constructor
proto_generic_file & | operator= (const proto_generic_file &ref)=default
| assignment operator
proto_generic_file & | operator= (proto_generic_file &&ref) noexcept=default
| move operator
virtual | ~proto_generic_file () noexcept(false)
| virtual destructor
Public Member Functions inherited from libdar::contextual
| contextual (const contextual &ref)=default
| contextual (contextual &&ref) noexcept=default
contextual & | operator= (const contextual &ref)=default
contextual & | operator= (contextual &&ref) noexcept=default
virtual void | set_info_status (const std::string &s)
| defines the new contextual value
virtual std::string | get_info_status () const
| get the current contextual value

## Protected Member Functions
virtual void | inherited_read_ahead (const infinint &amount) override
| tells the object that several calls to read() will follow to probably obtain at least the given amount of data
virtual U_I | inherited_read (char *a, U_I size) override
| implementation of read() operation
virtual void | inherited_write (const char *a, U_I size) override
| implementation of the write() operation
virtual void | inherited_truncate (const infinint &pos) override
| truncate file at the give offset
virtual void | inherited_sync_write () override
| write down any pending data
virtual void | inherited_flush_read () override
| reset internal engine, flush caches in order to read the data at current position
virtual void | inherited_terminate () override
| destructor-like call, except that it is allowed to throw exceptions
Protected Member Functions inherited from libdar::generic_file
void | set_mode (gf_mode x)
bool | is_terminated () const
void | set_mode (gf_mode x)
bool | is_terminated () const
Protected Member Functions inherited from libdar::mem_ui
user_interaction & | get_ui () const
| get access to the user_interaction object
std::shared_ptr< user_interaction > | get_pointer () const
| get access to the shared_ptr pointing to the user_interaction
void | change_ui (const std::shared_ptr< user_interaction > &new_dialog)
| change the user_interaction object
user_interaction & | get_ui () const
| get access to the user_interaction object
std::shared_ptr< user_interaction > | get_pointer () const
| get access to the shared_ptr pointing to the user_interaction
void | change_ui (const std::shared_ptr< user_interaction > &new_dialog)
| change the user_interaction object
| mem_ui (const std::shared_ptr< user_interaction > &dialog)
| constructor
| mem_ui (const mem_ui &ref)=default
| the copy constructor
| mem_ui (mem_ui &&ref) noexcept=default
| the move constructor
mem_ui & | operator= (const mem_ui &ref)=default
| assignement operator
mem_ui & | operator= (mem_ui &&ref) noexcept=default
| move operator
virtual | ~mem_ui () noexcept(false)
| destructor
| mem_ui (const std::shared_ptr< user_interaction > &dialog)
| constructor
| mem_ui (const mem_ui &ref)=default
| the copy constructor
| mem_ui (mem_ui &&ref) noexcept=default
| the move constructor
mem_ui & | operator= (const mem_ui &ref)=default
| assignement operator
mem_ui & | operator= (mem_ui &&ref) noexcept=default
| move operator
virtual | ~mem_ui () noexcept(false)
| destructor

## Private Member Functions
void | init (const label &internal_name)
| write the slice header and set the offset field (write mode), or (read-mode), reads the slice header an set offset field
void | where_am_i ()

## Private Attributes
generic_file * | reference
| points to the underlying data, owned by "this"
infinint | offset
| offset to apply to get the first byte of data out of SAR headers
infinint | cur_pos
| current position as returned by get_position()
infinint | end_of_slice
| when end of slice/archive is met, there is an offset by 1 compared to the offset of reference. end_of_slice is set to 1 in that situation, else it is always equal to zero
std::string | hook
| command to execute after slice writing (not used in read-only mode)
std::string | base
| basename of the archive (used for string susbstitution in hook)
std::string | ext
| extension of the archive (used for string substitution in hook)
label | of_data_name
| archive's data name
bool | old_sar
| true if the read sar has an old header (format <= "07") or the to be written must keep a version 07 format.
infinint | min_digits
| minimum number of digits in slice name
std::string | hook_where
| what value to use for p substitution in hook
std::string | base_url
| what value to use for u substitution in hook
bool | natural_destruction
| whether user command is executed once the single sliced archive is completed (disable upon user interaction)

## Additional Inherited Members
Public Types inherited from libdar::generic_file
enum | skippability { skip_backward , skip_forward , skip_backward , skip_forward }
enum | skippability { skip_backward , skip_forward , skip_backward , skip_forward }

## Detailed Description

"trivial sar" proposes the same interface a sar but does the work slightly differently using different constructors

depending on the constructor used trivial sar can:

- in write mode send the data to a arbitrary long slice (plain file)
- in read mode let read a single slice from a named pipe
- in write mode let write a single sliced archive to an anonymous pipe

Definition at line 53 of file trivial_sar.hpp.

## Constructor & Destructor Documentation

## ◆ trivial_sar() [1/4]

libdar::trivial_sar::trivial_sar | ( | const std::shared_ptr< user_interaction > & | dialog,
|  | gf_mode | open_mode,
|  | const std::string & | base_name,
|  | const std::string & | extension,
|  | const entrepot & | where,
|  | const label & | internal_nale,
|  | const label & | data_name,
|  | const std::string & | execute,
|  | bool | allow_over,
|  | bool | warn_over,
|  | bool | force_permission,
|  | U_I | permission,
|  | hash_algo | x_hash,
|  | const infinint & | min_digits,
|  | bool | format_07_compatible )

constructor to build a new single sliced archive

Parameters

  dialog | how to interact with the user
  open_mode | read_write or write_only are the only acceptable values
  base_name | archive basename to create
  extension | archive extension
  where | where to store the archive
  internal_nale | tag common to all slices of the archive
  data_name | tag that follows the data when archive is dar_xform'ed
  execute | command line to execute at end of slice creation
  allow_over | whether to allow overwriting
  warn_over | whether to warn before overwriting
  force_permission | whether to enforce slice permission or not
  permission | value of permission to use if permission enforcement is used
  x_hash | whether to build a hash of the slice, and which algo to use for that
  min_digits | is the minimum number of digits the slices number is stored with in the filename
  format_07_compatible | build a slice header backward compatible with 2.3.x

References min_digits.

Referenced by operator=(), operator=(), trivial_sar(), and trivial_sar().

## ◆ trivial_sar() [2/4]

libdar::trivial_sar::trivial_sar | ( | const std::shared_ptr< user_interaction > & | dialog,
|  | const std::string & | pipename,
|  | bool | lax )

constructor to read a (single sliced) archive from a pipe

Parameters

  dialog | how to interact with the user
  pipename | if set to '-' the data are read from standard input, else the given file is expected to be named pipe to read data from
  lax | whether to be laxist or follow the normal and strict controlled procedure

## ◆ trivial_sar() [3/4]

libdar::trivial_sar::trivial_sar | ( | const std::shared_ptr< user_interaction > & | dialog,
|  | int | filedescriptor,
|  | bool | lax )

Parameters

  dialog | how to interact with the user
  filedescriptor | if set to '-' the data are read from standard input, else the given file is expected to be named pipe to read data from
  lax | whether to be laxist or follow the normal and strict controlled procedure

## ◆ trivial_sar() [4/4]

libdar::trivial_sar::trivial_sar | ( | const std::shared_ptr< user_interaction > & | dialog,
|  | generic_file * | f,
|  | const label & | internal_name,
|  | const label & | data_name,
|  | bool | format_07_compatible,
|  | const std::string & | execute )

constructor to write a (single sliced) archive to a anonymous pipe

Parameters

  dialog | user interaction
  f | in case of exception the generic_file "f" is not released, this is the duty of the caller to do so, else (success), the object becomes owned by the trivial_sar and must not be released by the caller.
  internal_name | internal name ti use
  data_name | data name
  format_07_compatible | whether we have to avoid creating a slice trailer
  execute | command to execute after each slice

References libdar::generic_file::generic_file().

## Member Function Documentation

## ◆ disable_natural_destruction()

void libdar::trivial_sar::disable_natural_destruction | ( |  | ) |
| inline

disable execution of user command when destroying the current object

Definition at line 125 of file trivial_sar.hpp.

References natural_destruction.

## ◆ enable_natural_destruction()

void libdar::trivial_sar::enable_natural_destruction | ( |  | ) |
| inline

enable back execution of user command when destroying the current object

Definition at line 128 of file trivial_sar.hpp.

References natural_destruction.

## ◆ get_data_name()

virtual const label & libdar::trivial_sar::get_data_name | ( |  | ) | const
| inline override virtual

obtain the data_name of the archive (label associated with the archive's data)

Note
  label are conserved with dar_xform and archive isolation, but are not with archive merging or archive creation (full or differential backup)

Implements libdar::contextual.

Definition at line 119 of file trivial_sar.hpp.

References of_data_name.

## ◆ get_position()

virtual infinint libdar::trivial_sar::get_position | ( |  | ) | const
| inline override virtual

get the current read/write position

Implements libdar::generic_file.

Definition at line 115 of file trivial_sar.hpp.

References cur_pos.

## ◆ get_slice_header_size()

const infinint & libdar::trivial_sar::get_slice_header_size | ( |  | ) | const
| inline

size of the slice header

Definition at line 122 of file trivial_sar.hpp.

References offset.

## ◆ inherited_flush_read()

virtual void libdar::trivial_sar::inherited_flush_read | ( |  | ) |
| inline override protected virtual

reset internal engine, flush caches in order to read the data at current position

Note
  when the object relies on external object or system object to fetch the data from for reading, when a call to (inherited_)flush_read() occurs, the current object must not assume that any previously read data is still valid if it has internal buffers or the like and it should flush them asap. This call must not propagate the flush_read to any other gneric_file object it could rely on

Implements libdar::generic_file.

Definition at line 136 of file trivial_sar.hpp.

References reference.

## ◆ inherited_read()

virtual U_I libdar::trivial_sar::inherited_read | ( | char * | a,
|  | U_I | size )
| override protected virtual

implementation of read() operation

Parameters

  [in,out] | a | where to put the data to read
  [in] | size | says how much data to read

Returns
  the exact amount of data read and put into 'a'

Note
  read as much byte as requested, up to end of file stays blocked if not enough data is available and EOF not yet met. May return less data than requested only if EOF as been reached. in other worlds, EOF is reached when returned data is stricly less than the requested data Any problem shall be reported by throwing an exception.

Implements libdar::generic_file.

## ◆ inherited_read_ahead()

virtual void libdar::trivial_sar::inherited_read_ahead | ( | const infinint & | amount | ) |
| inline override protected virtual

tells the object that several calls to read() will follow to probably obtain at least the given amount of data

Parameters

  [in] | amount | is the maximum expected amount of data that is known to be read

Note
  this call may be implemented as a do-nothing call, its presence is only to allow optimization when possible, like in multi-threaded environment

Implements libdar::generic_file.

Definition at line 131 of file trivial_sar.hpp.

References reference.

## ◆ inherited_sync_write()

virtual void libdar::trivial_sar::inherited_sync_write | ( |  | ) |
| inline override protected virtual

write down any pending data

Note
  called after sanity checks from generic_file::sync_write() this method's role is to write down any data pending for writing in the current object it has not to be propagated to other gneric_file object this object could rely on

Implements libdar::generic_file.

Definition at line 135 of file trivial_sar.hpp.

References reference.

## ◆ inherited_terminate()

virtual void libdar::trivial_sar::inherited_terminate | ( |  | ) |
| override protected virtual

destructor-like call, except that it is allowed to throw exceptions

Note
  this method must never be called directly but using terminate() instead, generic_file class manages it to never be called more than once

Implements libdar::generic_file.

## ◆ inherited_truncate()

virtual void libdar::trivial_sar::inherited_truncate | ( | const infinint & | pos | ) |
| inline override protected virtual

truncate file at the give offset

Note
  if pos is greater than the current file size, this call may do nothing (not even enlarging the file)
  this call should always fail on a read-only generic_file
  implementation must throw exception if truncate is not possible for other reason than read/write access mode

Implements libdar::generic_file.

Definition at line 134 of file trivial_sar.hpp.

References cur_pos, offset, and reference.

## ◆ inherited_write()

virtual void libdar::trivial_sar::inherited_write | ( | const char * | a,
|  | U_I | size )
| override protected virtual

implementation of the write() operation

Parameters

  [in] | a | what data to write
  [in] | size | amount of data to write

Note
  must either write all data or report an error by throwing an exception

Implements libdar::generic_file.

## ◆ is_an_old_start_end_archive()

virtual bool libdar::trivial_sar::is_an_old_start_end_archive | ( |  | ) | const
| inline override virtual

returns whether the archive is a old archive (format < 8)

Implements libdar::contextual.

Definition at line 118 of file trivial_sar.hpp.

References old_sar.

## ◆ skip()

virtual bool libdar::trivial_sar::skip | ( | const infinint & | pos | ) |
| override virtual

skip at the absolute position

Parameters

  [in] | pos | the offset in byte where next read/write operation must start

Returns
  true if operation was successfull and false if the requested position is not valid (after end of file)

Note
  if requested position is not valid the reading/writing cursor must be set to the closest valid position

Implements libdar::generic_file.

## ◆ skip_relative()

virtual bool libdar::trivial_sar::skip_relative | ( | S_I | x | ) |
| override virtual

skip relatively to the current position

Implements libdar::generic_file.

## ◆ skip_to_eof()

virtual bool libdar::trivial_sar::skip_to_eof | ( |  | ) |
| inline override virtual

skip to the end of file

Implements libdar::generic_file.

Definition at line 112 of file trivial_sar.hpp.

References libdar::generic_file::is_terminated(), and reference.

## ◆ skippable()

virtual bool libdar::trivial_sar::skippable | ( | skippability | direction,
|  | const infinint & | amount )
| inline override virtual

whether the implementation is able to skip

Note
  the capability to skip does not mean that skip_relative() or skip() will succeed, but rather that the inherited class implementation does not by construction forbid the requested skip (like inherited class providing a generic_file interface of an anonymous pipe for example)

Implements libdar::generic_file.

Definition at line 110 of file trivial_sar.hpp.

References reference.

## ◆ truncatable()

virtual bool libdar::trivial_sar::truncatable | ( | const infinint & | pos | ) | const
| inline override virtual

whether the implementation is able to truncate to the given position

Implements libdar::generic_file.

Definition at line 114 of file trivial_sar.hpp.

References offset, and reference.

## Member Data Documentation

## ◆ base

std::string libdar::trivial_sar::base
| private

basename of the archive (used for string susbstitution in hook)

Definition at line 145 of file trivial_sar.hpp.

## ◆ base_url

std::string libdar::trivial_sar::base_url
| private

what value to use for u substitution in hook

Definition at line 151 of file trivial_sar.hpp.

## ◆ cur_pos

infinint libdar::trivial_sar::cur_pos
| private

current position as returned by get_position()

Definition at line 142 of file trivial_sar.hpp.

Referenced by get_position(), and inherited_truncate().

## ◆ end_of_slice

infinint libdar::trivial_sar::end_of_slice
| private

when end of slice/archive is met, there is an offset by 1 compared to the offset of reference. end_of_slice is set to 1 in that situation, else it is always equal to zero

Definition at line 143 of file trivial_sar.hpp.

## ◆ ext

std::string libdar::trivial_sar::ext
| private

extension of the archive (used for string substitution in hook)

Definition at line 146 of file trivial_sar.hpp.

## ◆ hook

std::string libdar::trivial_sar::hook
| private

command to execute after slice writing (not used in read-only mode)

Definition at line 144 of file trivial_sar.hpp.

## ◆ hook_where

std::string libdar::trivial_sar::hook_where
| private

what value to use for p substitution in hook

Definition at line 150 of file trivial_sar.hpp.

## ◆ min_digits

infinint libdar::trivial_sar::min_digits
| private

minimum number of digits in slice name

Definition at line 149 of file trivial_sar.hpp.

Referenced by trivial_sar().

## ◆ natural_destruction

bool libdar::trivial_sar::natural_destruction
| private

whether user command is executed once the single sliced archive is completed (disable upon user interaction)

Definition at line 152 of file trivial_sar.hpp.

Referenced by disable_natural_destruction(), and enable_natural_destruction().

## ◆ of_data_name

label libdar::trivial_sar::of_data_name
| private

archive's data name

Definition at line 147 of file trivial_sar.hpp.

Referenced by get_data_name().

## ◆ offset

infinint libdar::trivial_sar::offset
| private

offset to apply to get the first byte of data out of SAR headers

Definition at line 141 of file trivial_sar.hpp.

Referenced by get_slice_header_size(), inherited_truncate(), and truncatable().

## ◆ old_sar

bool libdar::trivial_sar::old_sar
| private

true if the read sar has an old header (format <= "07") or the to be written must keep a version 07 format.

Definition at line 148 of file trivial_sar.hpp.

Referenced by is_an_old_start_end_archive().

## ◆ reference

generic_file* libdar::trivial_sar::reference
| private

points to the underlying data, owned by "this"

Definition at line 140 of file trivial_sar.hpp.

Referenced by inherited_flush_read(), inherited_read_ahead(), inherited_sync_write(), inherited_truncate(), skip_to_eof(), skippable(), and truncatable().

The documentation for this class was generated from the following file:

- trivial_sar.hpp